## mingw-w64-libosmscout-2024.06.02.1-4.src.tar.zst

=== meson_options.txt ===
option('openmp',   type: 'boolean', value: true, description: 'use OpenMP if available')

option('enableGpx',        type: 'boolean', value: true, description: 'Build GPX library')
option('enableImport',     type: 'boolean', value: true, description: 'Build import library')
option('enableTests',      type: 'boolean', value: true, description: 'Build tests')
option('enableMapAgg',     type: 'boolean', value: true, description: 'Build AGG backend')
option('enableMapCairo',   type: 'boolean', value: true, description: 'Build Cairo backend')
option('enableMapDirectX', type: 'boolean', value: true, description: 'Build DirectX backend')
option('enableMapIOSX',    type: 'boolean', value: true, description: 'Build iOS/OS X backend')
option('enableMapOpenGL',  type: 'boolean', value: true, description: 'Build OpenGL backend')
option('enableMapQt',      type: 'boolean', value: true, description: 'Build Qt backend')
option('enableMapSvg',     type: 'boolean', value: true, description: 'Build SVG backend')
option('enableClientQt',   type: 'boolean', value: true, description: 'Build Qt/QML library')
option('enableXML',        type: 'boolean', value: true, description: 'Use libxml2')
option('qtVersion',        type: 'integer', value: 5, min: 5, max: 6, description: 'QT version to use (5 or 6)')
